﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using System.Xml.Linq;
using SimpleDigg.Digg;

namespace SimpleDigg
{
    public partial class MainPage : PhoneApplicationPage
    {
        // Constructor
        public MainPage()
        {
            InitializeComponent();
        }

        protected override void OnNavigatedTo(System.Windows.Navigation.NavigationEventArgs e)
        {
            base.OnNavigatedTo(e);

            WebClient digg = new WebClient();
            digg.DownloadStringCompleted += new DownloadStringCompletedEventHandler(digg_DownloadStringCompleted);
            digg.DownloadStringAsync(new Uri("http://services.digg.com/1.0/endpoint?method=topic.getAll"));
        }

        void digg_DownloadStringCompleted(object sender, DownloadStringCompletedEventArgs e)
        {
            if(e.Error != null) {
                return;
            }

            XElement topicXml = XElement.Parse(e.Result);

            var topics = from topic in topicXml.Descendants("topic")
                            select new Topic
                            {
                                Name = topic.Attribute("name").Value,
                                ShortName = topic.Attribute("short_name").Value
                            };
            TopicsList.ItemsSource = topics;
        }

        private void TopicsList_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            Topic topic = TopicsList.SelectedItem as Topic;
            NavigationService.Navigate(new Uri("/Topics/"+topic.ShortName, UriKind.Relative));
        }
    }
}
