﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using System.Xml.Linq;
using Microsoft.Phone.Shell;

namespace SimpleDigg.Views
{
    public partial class Stories : PhoneApplicationPage
    {
        public Stories()
        {
            InitializeComponent();
        }

        protected override void OnNavigatedTo(System.Windows.Navigation.NavigationEventArgs e)
        {
            base.OnNavigatedTo(e);

            String name;
            NavigationContext.QueryString.TryGetValue("Topic", out name);

            WebClient client = new WebClient();
            client.DownloadStringCompleted += new DownloadStringCompletedEventHandler(client_DownloadStringCompleted);
            client.DownloadStringAsync(new Uri("http://services.digg.com/1.0/endpoint?method=story.getAll&topic=" + name));
        }

        void client_DownloadStringCompleted(object sender, DownloadStringCompletedEventArgs e)
        {
            if (e.Error != null)
            {
                return;
            }

            XElement storyXml = XElement.Parse(e.Result);

            var stories = from story in storyXml.Descendants("story")
                          select new Digg.Story
                          {
                              Title = story.Element("title").Value,
                              Description = story.Element("description").Value,
                              Diggs = Int32.Parse(story.Attribute("diggs").Value),
                              Link = story.Attribute("link").Value
                          };
            StoriesList.ItemsSource = stories;
        }

        private void StoriesList_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            PhoneApplicationService.Current.State["Story"] = StoriesList.SelectedItem;
            NavigationService.Navigate(new Uri("/Story", UriKind.Relative));
        }
    }
}